<template>
    <section>
        <div class="container">
            <div class="row">
                <div class="shadow col-md-12 mt-4 p-3 mb-5 bg-white rounded">
                    <div class="float-left">
                        <a href="javascript:window.history.go(-1);"><i class="material-icons">arrow_back_ios</i> Regresar</a>
                    </div>
                    <h2 class="text-center">Asignación de Aspirantes</h2>
                </div>
            </div>

            <div class="row">
                
                <div class="col-md-6">
                    <div class="card">
                        <div class="card-body">
                            <h5 class="card-title">Debe seleccionar una carrera</h5>
                            <b-form @change="buscarEstudiantes">
                                <div class="row form-group">
                                    <div class="col">
                                        <label for>Carreras</label>
                                        <b-form-select v-model="carreraId" class="form-control">
                                            <option v-for="carrera in carreras" :key="carrera.id" :value="carrera.id">
                                                {{carrera.nombreCarrera}}
                                            </option>
                                        </b-form-select>
                                    </div>
                                </div>
                            </b-form>
                        </div>
                    </div>
                </div>

                <div class="col-md-6" v-show="carreraId > 0">
                    <div class="card">
                        <div class="card-body">
                            <h5 class="card-title">Seleccione los datos necesarios</h5>
                            <b-form @submit="registrarAsignacion">
                                <div class="row form-group">
                                    <div class="col">
                                        <label for>Estudiante:</label>
                                        <select v-model="aspiranteId" class="form-control">
                                            <option v-for="estudiante in listaAspirantes" :key="estudiante.id" :value="estudiante.id">
                                                {{estudiante.primerApellido}} {{estudiante.segundoApellido}}
                                            </option>
                                        </select>
                                    </div>
                                    <div class="col">
                                        <label for>Grupo:</label>
                                        <b-form-select v-model="grupoId" class="form-control">
                                            <option v-for="grupo in listaGrupos" :key="grupo.id" :value="grupo.id">
                                                {{grupo.gradoGrupo}} {{grupo.letraGrupo}}
                                            </option>
                                        </b-form-select>
                                    </div>
                                </div>
                                <div align-v="center">
                                    <b-button type="submit" block variant="outline-success">Registrar</b-button>
                                </div>

                            </b-form>
                        </div>
                    </div>
                </div>

            </div>

            <table v-show="asignaciones.length > 0" class="table table-hover table-light">
            <thead>
                <tr style="background-color: #019979">
                <!-- <th scope="col">#</th> -->
                <th scope="col" class="text-white lead">Aspirante</th>
                <th scope="col" class="text-white lead">Grupo</th>
                <th scope="col" class="text-white lead">Carrera</th>
                <th scope="col" class="text-white lead">Acciones</th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="(asignacion, index) in asignaciones" :key="index" class="table-light lead">
                <!-- <th scope="row">{{index}}</th> -->
                <td>{{asignacion.nombre}} {{asignacion.primerApellido}} {{asignacion.segundoApellido}}</td>
                <td>{{asignacion.gradoGrupo}} {{asignacion.letraGrupo}}</td>
                <td>{{asignacion.nombreCarrera}}</td>
                <td>
                    <b-button v-show="carreraId > 0" variant="warning" style="margin-right:20px;" v-b-tooltip.hover title="Modificar información" id="show-btn" @click="showModal('modal-modificar'); buscarEstudiantesModificar();llenarObjAsignacion(asignacion)"><i class="material-icons">create</i></b-button>
                    <b-button v-show="carreraId == null" variant="secondary" style="margin-right:20px;" v-b-tooltip.hover title="Seleccione una carrera" id="show-btn"><i class="material-icons">create</i></b-button> 
                    <b-button variant="danger" id="show-btn" @click="eliminarAsignacion(asignacion.id)" v-b-tooltip.hover title="Eliminar Registro"><i class="material-icons">delete</i></b-button>                
                </td>
                </tr>
            </tbody>
        </table>
        </div>
<!-- MODIFICAR ASIGNACIÓN -->
        <b-modal ref="modal-modificar" hide-footer title="Modificar Asignación">
            <div class="d-block text-left">
                <h3></h3>
            <b-form @submit="modificarAsignacion">
                <div class="row form-group">
                    <div class="col">
                        <label for>Grupo:</label>
                        <b-form-select v-model="objAsignacon.idGrupo" class="form-control" required>
                            <option v-for="grupo in listaGrupos" :key="grupo.id" :value="grupo.id">
                                {{grupo.gradoGrupo}} {{grupo.letraGrupo}}
                            </option>
                        </b-form-select>
                    </div>
                </div>
                <b-button type="submit" block variant="outline-success">Modificar</b-button>
            </b-form>
        </div>
        <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-modificar')">Cancelar</b-button>
    </b-modal>
    </section>
</template>

<script>
import axios from "axios";
import {server} from '../../store'
import {functions} from "../../functionsGolbals";
// import {mapGetters} from 'vuex';

export default {
    mixins: [functions],
    data(){
        return{
            user:[],
            output:[],
            listaAspirantes:[],
            listaGruposModificar:[],
            listaGrupos:[],
            carreras:[],
            asignaciones:[],
            objAsignacon:[],
            carreraId:null,
            aspiranteId:null,
            grupoId:null,
            idGrupoModificar:null
        }
    },
    mounted(){
        if(localStorage.getItem('usuario') == null){
          this.$router.push("/login");
        }else{
          this.user = JSON.parse(localStorage.getItem('usuario'));
        }
        this.obtenerListas();
        this.obtenerAsignaciones();
    },
    methods:{
        eliminarAsignacion(id){
            let currentObj = this;
            axios.post(`${server.baseURL}/api/grupo-carrera-aspirante/eliminar`, {
                    grupo_carrera_aspirante: {
                        id: id
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerListas();
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.alertError(currentObj.output.response.message);
                });     
        },
        llenarObjAsignacion: function (asignacion) {
            this.objAsignacon = asignacion
        },
        pasarListas(){
            this.listaAspirantes = this.output.response.listaGrupos;
            this.listaGrupos = this.output.response.listaAlumnos

        },
        pasarGrupos(){
            this.listaGruposModificar = this.output.response.listaAlumnos

        },
        obtenerListas(){
            axios
                .get(`${server.baseURL}/api/carrera/lista`)
                .then(data => (this.carreras = data.data));
        },
        obtenerAsignaciones(){
            axios
                .get(`${server.baseURL}/api/grupo-carrera-aspirante/lista`)
                .then(data => (this.asignaciones = data.data));
        },
        buscarEstudiantes(){
            let currentObj = this;
            axios.post(`${server.baseURL}/api/grupo-carrera-aspirante/listasParaRegistro`, {
                    carrera: {
                        id: this.carreraId,
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.pasarListas();
                })
                .catch(function (error) {
                    currentObj.output = error;
                   currentObj.alertError(currentObj.output.response.message);
                });
        },
        buscarEstudiantesModificar(){
            let currentObj = this;
            axios.post(`${server.baseURL}/api/grupo-carrera-aspirante/listasParaRegistro`, {
                    carrera: {
                        id: this.objAsignacon.idCarrera,
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.pasarGrupos();
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
        registrarAsignacion(e) {
            e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/grupo-carrera-aspirante/registro`, {
                    registro: {
                        grupoCarreraID: this.grupoId,
                        aspiranteId: this.aspiranteId,
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerAsignaciones();
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.obtenerAsignaciones();
                   currentObj.alertError(currentObj.output.response.message);
                });
        },
        modificarAsignacion(e) {
            e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/grupo-carrera-aspirante/modificar`, {
                    modificar: {
                        id: this.objAsignacon.id,
                        grupoCarreraID: this.objAsignacon.idGrupo,
                        aspiranteId: this.objAsignacon.idAspirante
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerAsignaciones();
                    currentObj.hideModal('modal-modificar');
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.obtenerAsignaciones();
                    currentObj.hideModal('modal-modificar');
                   currentObj.alertError(currentObj.output.response.message);
                });
        },
    }
}
</script>